
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputResLexer.g.
 * /!\ Don't edit it!
 */

#include <algorithm>

#include <QRegularExpression>

#include <Qsci/qsciscintilla.h>

#include <ShareablePoints/SPIOException.hpp>
#include <ShareablePoints/ShareableExtraInfos.hpp>
#include <ShareablePoints/ShareableFrame.hpp>
#include <ShareablePoints/ShareableParams.hpp>
#include <ShareablePoints/ShareablePoint.hpp>
#include <ShareablePoints/ShareablePosition.hpp>

#include "tabs/outputs/LGCOutputResLexer.hpp"

#define ADDSTYLE(rule, style) ADDSTYLEIDX((rule), style, 1)
#define ADDSTYLEIDX(rule, style, symidx) \
	case (rule): \
		addStyleSym(Styles::style, (symidx)); \
		break

#define FLAG_NO_FLAG			0x00
#define FLAG_IS_POINT			0x01
#define FLAG_IS_FRAME			0x02
#define FLAG_PRIORITIZE_POINT 	0x04
#define FLAG_PRIORITIZE_FRAME 	0x08

namespace
{
inline QString toTrimmedQString(const QStringRef &str)
{
	return str.trimmed().toString();
}
} // namespace

void LGCOutputResLexer::checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK, Styles styleError, const QString& additionalMessage)
{
	static const QString statusstring = tr(R"""(<h1 style="color: %1;">%2</h1>
		<p style="color: %1;">Value %3 is %4.</p>)""");

	if (!_lexerMode)
		return;

	bool ok = false;
	const double value = sym(symidx).toDouble(&ok);
	if (ok && (min > max || (value >= min && value <= max)))
	{
		addStyleSym(styleOK, symidx);
		return;
	}

	addStyleSym(styleError, symidx);
	QString color, header;
	if(marker == TextMarker::ERROR || marker == TextMarker::WARNING)
	{
		color = "red";
		header = "Error";
	}
	else
	{
		color = "blue";
		header = "Info";
	}

	if (min == max)
		_infoAnnotation += statusstring.arg(color).arg(header).arg(sym(symidx).toString()).arg(tr("not %1").arg(QString::number(min))) += additionalMessage;
	else
		_errorAnnotation += statusstring.arg(color).arg(header).arg(sym(symidx).toString()).arg(tr("out of range [%2; %3]").arg(QString::number(min), QString::number(max))) += additionalMessage;
	// add marker if none with higher priority was set before
	const int pos = sym(symidx).position();
	int line, index;
	editor()->lineIndexFromPosition(pos, &line, &index);
	const std::bitset<32> markers = editor()->markersAtLine(line);
	if (marker == TextMarker::ERROR
		|| (marker == TextMarker::WARNING && !markers[TextMarker::ERROR])
		|| (!markers[TextMarker::ERROR] && !markers[TextMarker::WARNING]))
		addMarker(editor(), pos, marker);
}

QString LGCOutputResLexer::findSummaryMeasureKey(const QString &instrType, const QString &pointName)
{
	QString msrid = instrType + '/' + pointName;
	int i = 0;
	while (_summaryMeasures.find(msrid + '/' + QString::number(i)) != std::cend(_summaryMeasures))
		i++;
	_summaryMeasures.insert(msrid + '/' + QString::number(i));
	return msrid + '/' + QString::number(i);
}

QString LGCOutputResLexer::setMeasure(const QString &type, const QString &measureName)
{
	if (!_lexerMode)
		return "";
	QString msrid = _curTmp + '/' + type + '/' + measureName;
	int i = 0;
	while (contains(_resData.measures, msrid + '/' + QString::number(i)))
		i++;
	_resData.measures.emplace(msrid + '/' + QString::number(i), LGCMeasures::Value{sym(1).position(), msrid + '/' + QString::number(i), measureName, _currentLine.toString(), type, _curTmp, _unusedComment});

	if (type == "OBSXYZ")
		i /= 3;
	return msrid + '/' + QString::number(i);
}

void LGCOutputResLexer::setFrame(QStringRef sym)
{
	QString name = toTrimmedQString(sym);
	if (contains(_inputData.frames, name))
		addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::frames));
}

void LGCOutputResLexer::setFrameOrPointInSummary()
{
	QString name = toTrimmedQString(sym(1));
	if (contains(_inputData.points, name))
		_pointOrFrameFlags = _pointOrFrameFlags | FLAG_IS_POINT;
	if (contains(_inputData.frames, name) || name == "ROOT") // since "ROOT" is the only possible "virtual" frame I don't create an extra case for it
		_pointOrFrameFlags = _pointOrFrameFlags | FLAG_IS_FRAME;
	switch(_pointOrFrameFlags)
	{
		case FLAG_IS_POINT | FLAG_PRIORITIZE_FRAME:
			[[fallthrough]];
		case FLAG_IS_POINT | FLAG_PRIORITIZE_POINT:
			// if only a point is found
			addStyleSym(Styles::PointName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::points));
			break;
		case FLAG_IS_FRAME | FLAG_PRIORITIZE_FRAME:
			[[fallthrough]];
		case FLAG_IS_FRAME | FLAG_PRIORITIZE_POINT:
			// if only frame is found
			addStyleSym(Styles::FrameName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::frames));
			break;
		case FLAG_IS_POINT | FLAG_IS_FRAME | FLAG_PRIORITIZE_POINT:
			addStyleSym(Styles::PointName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::points));
			break;
		case FLAG_IS_POINT | FLAG_IS_FRAME | FLAG_PRIORITIZE_FRAME:
			addStyleSym(Styles::FrameName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::frames));
			break;
		default:
			// if no case is hit I assume it is a virtual point created by LGC and colour it as a point without linkage
			addStyleSym(Styles::PointName, 1);
			break;
	}
}

void LGCOutputResLexer::contextChange(Context val)
{
	if (_contexts.empty())
		_contexts.push_back(val);
	else
		_contexts.back() = val;
}

void LGCOutputResLexer::consumeRule(int rule)
{
	switch(rule)
	{
 case 8: 
	case 9:
	{
		addStyleSym(Styles::PointName, 1);
		QString name = toTrimmedQString(sym(1));
		if (contains(_inputData.points, name))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::points));
		break;
	}

	case 10:
		addStyleSym(Styles::FrameName, 1);
		setFrame(sym(1));
		break;

	case 11:
		addStyleSym(Styles::Frame, 1);
		break;
 case 12:  case 13: 
	case 14:
		addStyle(_currentLine.length(), Styles::Normal);
		break;

	case 15:
	{
		addStyleSym(Styles::InstrumentName, 1);
		_curTmp = toTrimmedQString(sym(1));
		if (contains(_inputData.instruments, _curTmp))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(_curTmp, LGCMeasures::LGCMeasuresEnum::instruments));
		break;
	}

	case 16:
	{
		// Does not set a new instrument, meant to add styling and create a link
		addStyleSym(Styles::InstrumentName, 1);
		if (contains(_inputData.instruments, toTrimmedQString(sym(1))))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(toTrimmedQString(sym(1)), LGCMeasures::LGCMeasuresEnum::instruments));
		break;
	}

	case 17: //TGTNAMEDEF
	{
		addStyleSym(Styles::TargetName, 1);
		QString name = _curTmp + '/' + toTrimmedQString(sym(1));
		if (contains(_inputData.targets, name))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::targets));
		break;
	}

	case 25: // HEADER
		endFolding();
		break;

	case 28:
		startFolding();
		break;

	case 29:
		addStyleSym(Styles::Comment, 1);
		break;
 case 30:  case 31:  case 32:  case 33: 
	case 34:
		addStyleSym(Styles::Normal, 1);
		break;

	case 35:
		addStyleSym(Styles::Comment, 2);
		break;
 case 36:  case 37: 
	case 38:
		addStyleSym(Styles::Normal, 2);
		break;

	case 39: // SUMMARY
		endFolding();
		break;

	case 42:
		addStyleSym(Styles::Section, 1);
		contextChange(Context::SUMMARY);
		startFolding();
		break;
 case 43: 
	case 44:
		addStyleSym(Styles::Section, 1);
		break;
 case 45: 
	case 46:
		addStyleSym(Styles::Section, 2);
		break;

	case 47:
		addStyleSym(Styles::Comment, 1);
		break;

	case 52:
		addStyleSym(Styles::Normal, 1);
		break;

	case 53:
		addStyleSym(Styles::Normal, 2);
		break;

	case 54:
		addStyleSym(Styles::ValueImportant, 1);
		break;

	case 55:
		addStyleSym(Styles::Normal, 1);
		break;

	case 56:
		addStyleSym(Styles::Normal, 2);
		break;

	case 57:
		endFolding();
		break;

	case 59: // STATISTICS
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		contextChange(Context::STATISTICS_HEADER);
		startFolding();
		break;
 case 65: 
	case 66:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::ValueImportant, 3);
		break;

	case 68:
		addStyleSym(Styles::Normal, 1);
		contextChange(Context::STATISTICS_CONTENTS);
		break;

	case 69:
	{
		const double sigmamin = sym(6).mid(1).toDouble(); // All after (
		const double sigmamax = sym(8).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::ValueImportant, 6);
		addStyleSym(Styles::Normal, 7);
		addStyleSym(Styles::ValueImportant, 8);
		break;
	}

	case 70:
	{
		const double sigmamin = sym(7).toDouble();
		const double sigmamax = sym(9).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::ValueImportant, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::ValueImportant, 9);
		break;
	}

	case 73:
		addStyleSym(Styles::Comment, 1);
		break;
 case 74: 
	case 75:
		addStyleSym(Styles::Normal, 1);
		break;

	case 76:
		addStyleSym(Styles::Comment, 2);
		break;
 case 77: 
	case 78:
		addStyleSym(Styles::Normal, 2);
		break;

	case 79:
		addStyleSym(Styles::Normal, 1);
		_inlineContexts.insert(InlineCxt::STATISTICS_POINT);
		startFolding();
		break;

	case 80:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 8);
		break;

	case 81:
		_isOloc = true;
		addStyleSym(Styles::DatumOption, 1);
		if (!_lexerMode && _curFrame)
			_curFrame->getParams().extraInfos["coordinateSystem"] = std::string("*") + toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		break;
 case 82:  case 83: 
	case 84:
		_isOloc = false;
		addStyleSym(Styles::DatumOption, 1);
		if (!_lexerMode && _curFrame)
			_curFrame->getParams().extraInfos["coordinateSystem"] = std::string("*") + toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		break;

	case 87:
		_tmpcounter = 0;
		if (!_lexerMode && _curFrame)
			_curFrame->getPoint(_curFrame->sizePoints() - 1).name = toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		break;

	case 88:
		addStyleSym(Styles::PointName, 1);
		_tmpcounter = 0;
		break;

	case 91:
	{
		if (_contexts.empty())
			break;
		ShareablePoint *point = nullptr;
		size_t coordSize = _isOloc ? 3 : 4;
		size_t sigmaSize = 0;

		if (!_lexerMode && _tmpcounter == 0)
			point = &_curFrame->addPoint();
		else if (!_lexerMode)
			point = &_curFrame->getPoint(_curFrame->sizePoints() - 1);
			
		if (!_contexts.empty())
		{
			switch (_contexts.back())
			{
			case Context::STATISTICS_POINT_CALA:
				sigmaSize = 0;
				if (!_lexerMode)
				{
					point->position.isfreex = false;
					point->position.isfreey = false;
					point->position.isfreez = false;
				}
				break;
			case Context::STATISTICS_POINT_Z:
				sigmaSize = 1;
				if (!_lexerMode)
				{
					point->position.isfreex = false;
					point->position.isfreey = false;
					point->position.isfreez = true;
				}
				break;
			case Context::STATISTICS_POINT_XYZ:
				sigmaSize = 3;
				if (!_lexerMode)
				{
					point->position.isfreex = true;
					point->position.isfreey = true;
					point->position.isfreez = true;
				}
				break;
			case Context::STATISTICS_POINT_XY:
				sigmaSize = 2;
				if (!_lexerMode)
				{
					point->position.isfreex = true;
					point->position.isfreey = true;
					point->position.isfreez = false;
				}
				break;
			case Context::STATISTICS_POINT_XZ:
				sigmaSize = 2;
				if (!_lexerMode)
				{
					point->position.isfreex = true;
					point->position.isfreey = false;
					point->position.isfreez = true;
				}
				break;
			case Context::STATISTICS_POINT_YZ:
				sigmaSize = 2;
				if (!_lexerMode)
				{
					point->position.isfreex = false;
					point->position.isfreey = true;
					point->position.isfreez = true;
				}
				break;
			}
		}

		if (_tmpcounter < coordSize)
		{
			addStyleSym(Styles::PointCoord, 1);
			if (!_lexerMode && _tmpcounter == 0)
				point->position.x = sym(1).toDouble();
			else if (!_lexerMode && _tmpcounter == 1)
				point->position.y = sym(1).toDouble();
			else if (!_lexerMode)
				point->position.z = sym(1).toDouble();
		}
		else if (_tmpcounter >= coordSize + sigmaSize)
			checkNumberInRange(1, -_threshPDisplacement, _threshPDisplacement, TextMarker::WARNING);
		else
		{
			checkNumberInRange(1, -_threshPSigma, _threshPSigma, TextMarker::WARNING, Styles::PointSigma);
			
			if (_contexts.empty());  // Do nothing if contexts are empty
			else if (!_lexerMode && _tmpcounter == coordSize)
			{
				if (_contexts.back() == Context::STATISTICS_POINT_XYZ || _contexts.back() == Context::STATISTICS_POINT_XY || _contexts.back() == Context::STATISTICS_POINT_XZ)
					point->position.sigmax = sym(1).toDouble();
				else if (_contexts.back() == Context::STATISTICS_POINT_YZ)
					point->position.sigmay = sym(1).toDouble();
				else if (_contexts.back() == Context::STATISTICS_POINT_Z)
					point->position.sigmaz = sym(1).toDouble();
			}
			else if (!_lexerMode && _tmpcounter == coordSize + 1)
			{
				if (_contexts.back() == Context::STATISTICS_POINT_XYZ || _contexts.back() == Context::STATISTICS_POINT_XY)
					point->position.sigmay = sym(1).toDouble();
				else if (_contexts.back() == Context::STATISTICS_POINT_XZ || _contexts.back() == Context::STATISTICS_POINT_YZ)
					point->position.sigmaz = sym(1).toDouble();
			}
			else if (!_lexerMode)
				point->position.sigmaz = sym(1).toDouble();
		}
		_tmpcounter++;
		break;
	}

	case 97:
		if (!_contexts.empty())
			_contexts.pop_back();
		endFolding();
		break;

	case 104:
		_contexts.push_back(Context::STATISTICS_POINT_CALA);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::PointType, 3);
		break;

	case 105:
		_contexts.push_back(Context::STATISTICS_POINT_XYZ);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;

	case 106:
		_contexts.push_back(Context::STATISTICS_POINT_XY);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;

	case 107:
		_contexts.push_back(Context::STATISTICS_POINT_XZ);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;

	case 108:
		_contexts.push_back(Context::STATISTICS_POINT_YZ);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;

	case 109:
		_contexts.push_back(Context::STATISTICS_POINT_Z);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		addStyleSym(Styles::Normal, 5);
		break;

	case 110:
		addStyleSym(Styles::Normal, 1);
		break;

	case 111:
		endFolding();
		break;
 case 113: 
	case 114:
		addStyleSym(Styles::PointType, 1);
		addStyleSym(Styles::PointType, 2);
		addStyleSym(Styles::PointType, 3);
		startFolding();
		break;

	case 127:
		endFolding();
		break;

	case 129:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::PointType, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::Normal, 9);
		break;

	case 130:
		addStyleSym(Styles::Normal, 1);
		_inlineContexts.insert(InlineCxt::STATISTICS_POINT);
		startFolding();
		break;

	case 132:
		addStyleSym(Styles::PointType, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 133:
		addStyleSym(Styles::Normal, 1);
		break;
 case 134: 
	case 135:
		endFolding();
		_summaryMeasures.clear();
		break;

	case 137: // MEASURES SUMMARY
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		addStyleSym(Styles::Section, 4);
		addStyleSym(Styles::Section, 5);
		contextChange(Context::MEASURES_SUMMARY);
		startFolding();
		break;

	case 140:
		endFolding();
		_curTmp.clear();
		_summaryMeasures.clear();
		break;
 case 144:  case 145:  case 146:  case 147:  case 148:  case 149:  case 150:  case 151:  case 152:  case 153: 
	case 154:
		addStyleSym(Styles::MeasureType, 1);
		[[fallthrough]];

	case 155:
		_pointOrFrameFlags = FLAG_PRIORITIZE_POINT;
		startFolding();
		_curTmp = toTrimmedQString(sym(1));
		break;
 case 156:  case 157: 
	case 158:
		addStyleSym(Styles::MeasureType, 1);

	case 159:
		_pointOrFrameFlags = FLAG_PRIORITIZE_FRAME;
		startFolding();
		_curTmp = toTrimmedQString(sym(1));
		break;
 case 160:  case 161:  case 162: 
	case 163:
		addStyleSym(Styles::MeasureType, 1);

	case 164:
		_pointOrFrameFlags = FLAG_PRIORITIZE_POINT;
		startFolding();
		_curTmp = toTrimmedQString(sym(1));
		break;

	case 165:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		break;

	case 166:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		break;

	case 167:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		break;
 case 170: 
	case 171:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);

		setFrameOrPointInSummary();

		if (_lexerMode)
		{
			int line, index;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &index);
			// knowing previous summary measures, get the next unique msrid that identifies section in MEASURES
			// even if the same measure was already defined before
			QString msrid = findSummaryMeasureKey(_curTmp, _curTmp == "ORIE" ? "" : toTrimmedQString(sym(1)));
			_summarylineToMeasure[line] = msrid;
			addIndicationSym(TextIndicator::INTERNAL, 2);
			addIndicationSym(TextIndicator::INTERNAL, 3);
			addIndicationSym(TextIndicator::INTERNAL, 4);
			addIndicationSym(TextIndicator::INTERNAL, 5);
		}
		break;

	case 173:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::ValueImportant, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 7);
		break;

	case 174:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::ValueImportant, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 8);
		break;

	case 177:
		endFolding();
		break;

	case 179:
		addStyleSym(Styles::Normal, 1);
		startFolding();
		break;

	case 182:
		addStyleSym(Styles::Comment, 1);
		break;

	case 186:
		addStyleSym(Styles::Normal, 1);
		break;
 case 187: 
	case 188:
		addStyleSym(Styles::Comment, 1);
		break;
 case 189: 
	case 190:
		addStyleSym(Styles::Comment, 2);
		break;

	case 191:
	{
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		checkNumberInRange(5, 0, 0, TextMarker::ERROR);
		break;
	}
 case 192: 
	case 194:
		addStyleSym(Styles::Normal, 1);
		break;

	case 195:
		checkNumberInRange(1, -_threshMSigma, _threshMSigma, TextMarker::WARNING);
		break;

	case 196:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 197:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::ValueImportant, 2);
		break;

	case 198:
		checkNumberInRange(1, 0, 0, TextMarker::INFO, Styles::Normal, Styles::ValueImportant);

		if (!_lexerMode)
			return;
		break;

	case 199: // MSRIDTEXT
		addStyleSym(Styles::Normal, 1);
		break;
 case 200:  case 201:  case 202:  case 203: 
	case 204:
		addStyleSym(Styles::Normal, 1);
		break;
 case 205:  case 206:  case 207:  case 208: 
	case 209:
		addStyleSym(Styles::Normal, 2);
		break;

	case 210:
		addStyleSym(Styles::PointCoord, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::PointCoord, 3);
		addStyleSym(Styles::Normal, 4);
		break;

	case 211:
		endFolding();
		break;

	case 213: // MEASURES
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		contextChange(Context::MEASURES);
		startFolding();
		break;
 case 216:  case 217:  case 218:  case 219:  case 220:  case 221:  case 222: 
	case 223:
		endFolding();
		_curTmp.clear();
		_curHeaderPoint.clear();
		break;

	case 227: // CAM
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;

	case 228:
		addStyleSym(Styles::Normal, 1);
		_curHeaderPoint = toTrimmedQString(sym(2));
		break;
 case 231: 
	case 232:
		endFolding();
		break;

	case 235: // EDM
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;

	case 236:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		_curHeaderPoint = toTrimmedQString(sym(3));
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DSPT", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "DSPT", _curHeaderPoint});
		}
		break;
 case 240: 
	case 241:
		if (_lexerMode)
		{
			QString msrid = setMeasure("DSPT", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 244: // DLEV
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;

	case 245:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		_curHeaderPoint = toTrimmedQString(sym(3));
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DLEV", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "DLEV", _curHeaderPoint});
		}
		break;
 case 248: 
	case 249:
		if (_lexerMode)
		{
			QString msrid = setMeasure("DLEV", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
			{
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
				// Depending on DHOR provide different behavior
				if (_inputData.measures.at(msrid).representation.contains("DHOR"))
				{
					checkNumberInRange(14, 0, 0, TextMarker::INFO, Styles::Normal, Styles::ValueImportant);
					checkNumberInRange(9, -_threshMSigma, _threshMSigma, TextMarker::WARNING);
				}
				else
					checkNumberInRange(9, 0, 0, TextMarker::INFO, Styles::Normal, Styles::ValueImportant);
			}
		}
		break;

	case 254: // ORIE
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		addStyleSym(Styles::MeasureType, 4);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ORIE", "");
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ORIE", ""});
		}
		break;
 case 257: 
	case 258:
		// TGTNAMEDEF cannot have indicator since ORIE in the results does not display the instrument name that we can refer to
		if (_lexerMode)
		{
			_curTmp = toTrimmedQString(sym(1));
			QString msrid = setMeasure("ORIE", toTrimmedQString(sym(2)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 3, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 261: // POLAR
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;

	case 262:
		addStyleSym(Styles::Normal, 1);
		_curHeaderPoint = toTrimmedQString(sym(2));
		break;
 case 265:  case 266:  case 267:  case 268:  case 269:  case 270: 
	case 271:
		endFolding();
		break;

	case 274: // TSTNANGL
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ANGL", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNANGL", _curHeaderPoint});
		}
		break;
 case 277: 
	case 278:
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNANGL", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 281: // TSTNECDIR
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ECDIR", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNECDIR", _curHeaderPoint});
		}
		break;
 case 284: 
	case 285: // MsrTstnMeasureEcdirMeasure
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNECDIR", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 288: // TSTNECTH
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ECTH", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNECTH", _curHeaderPoint});
		}
		break;
 case 291: 
	case 292: // MsrTstnMeasureEcthMeasure
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNECTH", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 295: // TSTNDHOR
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DHOR", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNDHOR", _curHeaderPoint});
		}
		break;
 case 298: 
	case 299: // MsrTstnMeasureDhorMeasure
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNDHOR", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 302: // TSTNZEND
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ZEND", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNZEND", _curHeaderPoint});
		}
		break;
 case 305: 
	case 306:
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNZEND", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
			if (contains(_resData.measures, msrid))
				_resData.measures.at(msrid).others.append(";H_TGT:" + toTrimmedQString(sym(6)));
		}
		break;

	case 309: // TSTNDIST
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DIST", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNDIST", _curHeaderPoint});
		}
		break;
 case 312: 
	case 313:
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNDIST", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
			if (contains(_resData.measures, msrid))
				_resData.measures.at(msrid).others.append(";H_TGT:" + toTrimmedQString(sym(7)));
			QString zendmsrid = msrid.replace("TSTNDIST", "TSTNZEND");
			if (contains(_resData.measures, zendmsrid))
			{
				const LGCMeasures::Value &zend = _resData.measures[zendmsrid];
				double H_TGT = zend.others.mid(zend.others.indexOf("H_TGT:") + QString("H_TGT:").length()).toDouble();
				checkNumberInRange(7, H_TGT, H_TGT, TextMarker::WARNING, Styles::Normal, Styles::ValueError, tr(R"""(<p style="color: red;">The values of height for ZEND and DIST should match.</p>)"""));
			}
		}
		break;

	case 316: // TSTNPLR3D
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("PLR3D", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNPLR3D", _curHeaderPoint});
		}
		break;

	case 319:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 8);

		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNPLR3D", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
			{
				addIndicationSym(TextIndicator::EXTERNAL, 3, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
				addIndicationSym(TextIndicator::EXTERNAL, 5, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
				addIndicationSym(TextIndicator::EXTERNAL, 7, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
			}
			//QString msrid = setMeasure("TSTNPLR3D/" + toTrimmedQString(sym(1)), 5);
			//QString msrid = setMeasure("TSTNPLR3D/" + toTrimmedQString(sym(1)), 7);
		}
		break;

	case 322: // CAMUVEC
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("UVEC", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "CAMUVEC", _curHeaderPoint});
		}
		break;
 case 325: 
	case 326:
		if (_lexerMode)
		{
			QString msrid = setMeasure("CAMUVEC", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 329: // CAMUVD
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		addStyleSym(Styles::MeasureType, 4);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("UVD", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "CAMUVD", _curHeaderPoint});
		}
		break;
 case 332: 
	case 333:
		if (_lexerMode)
		{
			QString msrid = setMeasure("CAMUVD", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 339: // ECHO
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 340:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		if (_lexerMode)
		{
			_curHeaderPoint = toTrimmedQString(sym(3));
			QString msrid = findSummaryMeasureKey("ECHO", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ECHO", _curHeaderPoint});
		}
		break;
 case 343: 
	case 344:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECHO", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 347: // ECSP
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		break;

	case 348:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 3);
		// if (_lexerMode) { } // measure for ECHOLINE should be added here to link the summary with it but this name is not repeated
		// either this is TODO for LGC to place it somewhere or LGC-plugin will need to track it itself
		break;
 case 351: 
	case 352:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECSP", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 355: // ECVE
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;

	case 356:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::ValueImportant, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::ValueImportant, 9);
		addStyleSym(Styles::Normal, 10);
		addStyleSym(Styles::ValueImportant, 11);
		// if (_lexerMode) { } // measure for ECVELINE0 should be added here to link the summary with it but this name is not repeated
		// either this is TODO for LGC to place it somewhere or LGC-plugin will need to track it itself
		break;
 case 359: 
	case 360:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECVE", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 364:
		addStyleSym(Styles::MeasureType, 1);
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("INCLY", _curTmp);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "INCLY", ""});
		}
		break;
 case 367: 
	case 368:
		if (_lexerMode)
		{
			QString msrid = setMeasure("INCLY", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 372:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		if (_lexerMode)
		{
			_curHeaderPoint = toTrimmedQString(sym(7));
			QString msrid = findSummaryMeasureKey("ECWS", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ECWS", _curHeaderPoint});
		}

		break;

	case 373:
		addStyleSym(Styles::MeasureType, 1);
		break;
 case 376:  case 377:  case 378: 
	case 379:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECWS", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 383:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		if (_lexerMode)
		{
			_curHeaderPoint = toTrimmedQString(sym(4));
			QString msrid = findSummaryMeasureKey("ECWI", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ECWI", _curHeaderPoint});
		}

		break;

	case 384:
		addStyleSym(Styles::MeasureType, 1);
		break;
 case 387: 
	case 388:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECWI", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 394:
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DVER", "ROOT");
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "DVER", ""});
		}
		break;
 case 397: 
	case 398:
		if (_lexerMode)
		{
			QString msrid = setMeasure("DVER", toTrimmedQString(sym(1)) + toTrimmedQString(sym(2)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 3, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 401:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		addStyleSym(Styles::MeasureType, 4);
		addStyleSym(Styles::MeasureType, 5);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("OBSXYZ", _curTmp.isEmpty() ? "ROOT" : _curTmp);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "OBSXYZ", ""});
		}
		break;
 case 404:  case 405: 
	case 406:
		addStyleSym(Styles::Normal, 2);

		if (_lexerMode)
		{
			QString msrid = setMeasure("OBSXYZ", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 3, _inputData.measures.at(msrid).position);
		}
		break;

	case 409:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("RADI", "ROOT");
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "RADI", ""});
		}
		break;

	case 410:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		break;
 case 413: 
	case 414:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);

		if (_lexerMode)
		{
			QString msrid = setMeasure("RADI", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;

	case 415: // Erel
		endFolding();
		break;

	case 417:
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		startFolding();
		break;

	case 418:
		addStyleSym(Styles::Comment, 1);
		break;

	case 423: // ErelFrame
		endFolding();
		break;

	case 425:
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		startFolding();
		break;

	case 426:
		addStyleSym(Styles::Comment, 1);
		break;

	case 430:
		addStyle(_currentLine.length(), Styles::Normal);
		break;
 case 434:  case 435: 
	case 436:
		_curTmp = toTrimmedQString(sym(2));
		break;

	case 438:
		addStyle(_currentLine.length(), Styles::ValueImportant);
		
		_curTmpFrameLevelNext = sym(1).count('_');
		if(!_curTmpFrameLevelNext) // skip ROOT
			break; 
		else if(_curTmpFrameLevelNext < _curTmpFrameLevel) // Move from nested to outer
		{
			for (int i = 0; i < _curTmpFrameLevel - _curTmpFrameLevelNext + 1; i++)
				endFolding();
		}
		else if(_curTmpFrameLevelNext == _curTmpFrameLevel) // Move from same to same
			endFolding();
		_curTmpFrameLevel = _curTmpFrameLevelNext;
			
		startFolding();
		break;

	case 442:
		addStyle(_currentLine.length(), Styles::Normal);
		break;

	case 454: // FRAME MEASURES
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		break;
 case 458:  case 459: 
	case 460:
		endFolding();
		break;
 case 466:  case 467:  case 468: 
	case 469:
		endFolding();
		_curTmp.clear();
		_curHeaderPoint.clear();
		break;

	case 473:
		if (!_contexts.empty())
			_contexts.pop_back();
		endFolding();
		break;

	case 487: // END
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		addStyleSym(Styles::Section, 4);
		addStyleSym(Styles::Section, 5);
		for (int i = 0; i < (_curTmpFrameLevel); i++)
			endFolding();
		break;

	} // of the switch
}

int LGCOutputResLexer::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();

	if (!tval.isEmpty())
	{
		// sections
		if (!_contexts.empty())
		{
			if (_contexts.back() == Context::HEADER && value.position() == _currentLine.position() && _currentLine.startsWith(LGCOutputResLexer::spell[LGCOutputResLexer::SUMMARY_START]))
				return LGCOutputResLexer::SUMMARY_START;
			if (_contexts.back() == Context::SUMMARY && value.position() == _currentLine.position() && _currentLine.startsWith(LGCOutputResLexer::spell[LGCOutputResLexer::STATISTICS_START]))
				return LGCOutputResLexer::STATISTICS_START;
		}
		// keywords
		if (tval == LGCOutputResLexer::spell[LGCOutputResLexer::IND])
			return LGCOutputResLexer::IND;
		if (value.position() == _currentLine.position() && (_contexts.empty() || _contexts.back() > Context::SUMMARY) || !_inlineContexts.empty())
		{
			QString tmptok;
			for (int i = 0; i < LGCOutputResLexer::TERMINAL_COUNT; i++)
			{
				if (tval == LGCOutputResLexer::spell[i])
					return i;
				tmptok = LGCOutputResLexer::spell[i];
				if (tmptok.contains(' ') && _currentLine.trimmed().startsWith(LGCOutputResLexer::spell[i]))
					return i;
			}
		}
		// special characters
		if (std::all_of (std::cbegin(tval), std::cend(tval), [](const auto &ch) -> bool { return ch == '*'; }))
			return LGCOutputResLexer::ASTERISKS;
		if (tval.size() == 1)
		{
			switch (tval[0].unicode())
			{
			case ':':
				return LGCOutputResLexer::COLON;
			case '=':
				return LGCOutputResLexer::EQUAL;
			}
		}
		// numbers
		if (numericrgx.match(tval).hasMatch())
		{
			bool ok;
			tval.toInt(&ok);
			if (ok)
				return LGCOutputResLexer::INTEGER;
			tval.toDouble(&ok);
			if (ok)
				return LGCOutputResLexer::DECIMAL;
		}
		return LGCOutputResLexer::WORD;
	}

	return LGCOutputResLexer::UNKNOWN;
}
